AppTitle"Memory by Travis"
SeedRnd MilliSecs()

Graphics 1024,768,32,1

Global TileGfx = LoadAnimImage("Tiles.jpg",128,128,0,25)
Global MausGfx = CreateImage(20,20)

SetBuffer ImageBuffer(MausGfx)
 Color 0,0,255
 Line 10,0,10,20
 Line 0,10,20,10
SetBuffer BackBuffer()

Type Card
 Field x,y,pic,id,status,mem
End Type

Global Font0 = LoadFont("Arial", 16, 1)
Global Font1 = LoadFont("Arial", 40, 1)
Global Font2 = LoadFont("Arial", 12, 0)
Global Font3 = LoadFont("Arial", 25, 1)

.NewGame
For c.card = Each card
 Delete c
Next

Dim Storage(25,1)
Dim TempStorage(25)

Global open=0, halfopen=0, close=0 
Global waitmoment, timerwait 
Global tempid1, tempid2
Dim    WrongTurn(2)
Dim    RightTurn(2)
Global GameRunning=1, GameSecs=0, GameTimer
Global CurrentPlayer = 1
Global GameMode = 1
Global Winner = 3


For i = 0 To 11
 Storage(i,0) = Rnd(1,22)
Next

.again
For a = 0 To 11
 For b = 0 To 11
  If a <> b Then
   If Storage(a,0) = Storage(b,0) Then 
    Storage(b,0) = Rnd(1,22): Goto again
   EndIf
  EndIf
 Next
Next

For i = 12 To 24
 Storage(i,0) = Storage(i-12,0)
Next


tmp = 0
Repeat
 zufall = Rnd(23)

 If Storage(zufall,1) = 0 Then
  Storage(zufall,1) = 1
  TempStorage(tmp) = Storage(zufall,0)
  tmp = tmp + 1
 EndIf

Until tmp = 24


id = 0
For y = 0 To 4
 For x = 0 To 4
  c.card = New card
  c\x = (x*129)+50
  c\y = (y*129)+60    
  c\pic = TempStorage(id)
  c\id = id
  c\status = 0
  close = close + 1
  id = id + 1
  c\mem = 0
 Next
Next 

c.card = Last card
Delete c
close = close - 1



GameTimer = MilliSecs()
GameRunning = 1

Repeat
 ClsColor 0,0,32
 Cls

  UpdateScreen()
  UpdateInput()
  If UpdateGame() = 1 Then Goto newgame 

 Flip
Until KeyHit(1)
End



Function UpdateGame()

 If GameRunning = 1 Then

  If MilliSecs()-GameTimer > 1000 Then
   GameTimer = MilliSecs()
   GameSecs = GameSecs + 1
  EndIf

  If Close = 0 Then
   If RightTurn(0) > RightTurn(1) Then Winner = 0
   If RightTurn(0) < RightTurn(1) Then Winner = 1
   If RightTurn(0) = RightTurn(1) Then Winner = 3
   GameRunning = 0
  EndIf

 Else

  If KeyHit(57) Then
   Return 1
  EndIf

 EndIf


 If waitmoment = 1 Then

  If CurrentPlayer = 0 Then 
   WaitTime = 2000
  Else
   WaitTime = 1000
  EndIf


  If MilliSecs()-TimerWait > WaitTime Then
   waitmoment = 0
   Flip

   c.card = Object.card(tempid1)
   c\status = 0
   c.card = Object.card(tempid2)
   c\status = 0

   temppic1 = 0
   halfopen = 0

   If GameMode = 1 Then CurrentPlayer = CurrentPlayer Xor 1
  EndIf
 EndIf 


  If halfopen = 2 Then

   For c.card = Each card
    If c\status = 1 Then
     If temppic1 = 0 Then 
      temppic1 = c\pic
      tempid1 = Handle(c)
     Else 
      temppic2 = c\pic
      tempid2 = Handle(c)
     EndIf
    EndIf
   Next

   If temppic1 = temppic2 And temppic1 <> 0 Then
    c.card = Object.card(tempid1)
    c\status = CurrentPlayer+2
    c.card = Object.card(tempid2)
    c\status = CurrentPlayer+2

    temppic1 = 0
    halfopen = 0
    open = open + 2
    close = close - 2
    RightTurn(CurrentPlayer) = RightTurn(CurrentPlayer) + 1
    If GameMode = 1 Then CurrentPlayer = CurrentPlayer Xor 1
   Else
    If waitmoment = 0 Then waitmoment = 1 : timerwait = MilliSecs(): WrongTurn(CurrentPlayer) = WrongTurn(CurrentPlayer) + 1
   EndIf

  EndIf

End Function


Function UpdateScreen()
  
  For c.card = Each card

   If c\status = 0 Then 
    DrawImage TileGfx, c\x, c\y, 23
   Else
    DrawImage TileGfx, c\x, c\y, c\pic
    If c\status <> 1 Then
     If c\status = 2 Then Color 255,0,0
     If c\status = 3 Then Color 0,0,255

     Rect c\x,c\y,128,128,0:  Rect c\x+1,c\y+1,126,126,0
    EndIf
   EndIf

  Next

 
  SetFont Font1
  Color 0,0,128
  Text 800,55,"Memory"

  SetFont Font2
  Text 790,87,"Copyright (C) 2008 by Travis"

  SetFont Font3
  Color 0,0,128: Text 730, 150, "Spieler    Richtig    Falsch"
  Color 0,0,255: Text 742, 180, "Eins": Text 855,180, RightTurn(1): Text 945,180, WrongTurn(1)
  Color 255,0,0: Text 742, 200, "Zwei": Text 855,200, RightTurn(0): Text 945,200, WrongTurn(0)

  If Not GameRunning Then
   If Winner = 0 Then Color 255,0,0: w$="Spieler Zwei"
   If Winner = 1 Then Color 0,0,255: w$="Spieler Eins"
   Text 730,250, "Sieger: " + w$
   Text 730,280, "Leertaste fr neues Spiel."
  EndIf

End Function


Function UpdateInput()

 If CurrentPlayer = 1 Then
  For c.card = Each card
   If MouseOver(c\x,c\y,128,128) Then 
    If c\status = 0 And waitmoment = 0 Then DrawImage TileGfx, c\x, c\y, 24
    If MouseHit(1) Then
     If c\status = 0 And halfopen < 2 Then
      c\status = 1
      halfopen = halfopen + 1
     EndIf
    EndIf
   EndIf
  Next
 EndIf

 Include "KI.bb"

 If Not WaitMoment Then DrawImage MausGfx, MouseX(), MouseY()
End Function

Function MouseOver(x,y,w,h)
 mx = MouseX()
 my = MouseY()
 If mx > x And mx < x+w And my > y And my < y+h Then Return 1
End Function